Index: lib/spatial/mapbuilder/lib/tool/Extent.js
===================================================================
--- lib/spatial/mapbuilder/lib/tool/Extent.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/Extent.js	(revision 4307)
@@ -1,7 +1,7 @@
 /*
 Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Extent.js 3067 2007-08-03 09:25:59Z jseb.baklouti $
 */
 
 
@@ -9,7 +9,7 @@
 var degToMeter = Rearth*2*Math.PI/360;
 //var mbScaleFactor = 72 * 39.3701;   //PixelsPerInch*InchesPerMapUnit; magic numbers 
                                     //need to determine magic number for lat/lon
-var mbScaleFactor = 3571.428   //magic number, for Geoserver SLD compatibility
+var mbScaleFactor = 3571.428;   //magic number, for Geoserver SLD compatibility
                                // 1/0.00028 (0.28 mm "is a common actual size for
                                // contemporary display" as written in the SLD specification ...
 
@@ -37,12 +37,108 @@
  */
 function Extent( model, initialRes ) {
   this.model = model;
+  this.id = model.id + "_MbExtent" + mbIds.getId();
   this.size = new Array();
   this.res = new Array();
   this.zoomBy = 4;
-  this.id = model.id + "_MbExtent" + mbIds.getId();
-
+  
   /**
+   * Returns the bounding box as stored in the model
+   * @return array with the bounding box
+   */
+  this.getBbox = function() {
+    var bbox = this.model.getBoundingBox();
+    return bbox;
+  }
+  
+  /**
+   * Recalculates a given bbox and stores a proper aspect one in the model
+   * @param bbox  an array with a bounding box
+   */
+  this.setBbox = function(bbox){
+    size = this.getSize();
+    res = Math.max((bbox[2] - bbox[0])/size[0], (bbox[3] - bbox[1])/size[1]);
+    scale=this.getFixedScale(res);
+    center = new Array((bbox[1]-bbox[3])/2,(bbox[0]-bbox[2])/2);//center=horizontal,vertical
+    half = new Array(size[0]/2,size[1]/2);
+    bbox = new Array(center[0]-half[0]*scale, center[1]-half[1]*scale, center[0]+half[0]*scale,center[1]+half[1]*scale);
+    this.model.setBoundingBox(bbox);
+  }
+  
+   /**
+   * Returns the window size as stored in the model
+   * @return array with the window size
+   */
+  this.getSize = function() {
+    size= new Array();
+    size[0] = this.model.getWindowWidth();
+    size[1] = this.model.getWindowHeight();
+    return size;
+  }
+  
+   /**
+   * Stores a given window size in the model.
+   * Can be used in the future for dynamic window resizing
+   * @param size  an array with a window size
+   */
+  this.setSize = function(size){
+    this.model.setWindowWidth(size[0]);
+    this.model.setWindowHeight(size[1]);
+  }
+  
+   /**
+   * When given a res, it recalculates it to match the zoomlevels, when present and returns a fixed scale.
+   * When no res is given it returns the maximum resolution
+   * @param res optional resolution to be checked
+   * @return fixedScale the resolution to display the map with
+   */
+  this.getFixedScale = function(res) {
+  if (this.zoomLevels){
+    if (!res) {
+      this.setResolution( new Array(this.model.getWindowWidth(), this.model.getWindowHeight() ) );
+      res = Math.max(this.res[0],this.res[1]);
+     
+    }
+    var sortstring = "function sort(a,b){return b-a}";
+    var evalsort= eval(sortstring);
+    var zoomLevels = this.zoomLevels.sort(evalsort);
+    var i=0;
+    while(zoomLevels[i] >= res){
+      i++;
+    }
+    if(i==0) {
+    i=1;
+    }
+    this.fixedScale = zoomLevels[i-1];
+    }
+    else this.fixedScale = Math.max(this.res[0],this.res[1]);
+    return this.fixedScale;
+    
+  }
+  
+  /* 
+   * Sets the zoomLevels in the extent
+   * @param enabled boolean to enable or disable zoomLevels support
+   * @param zoomLevels an array containing a fixed set of zoomLevels
+   */
+  this.setZoomLevels = function(enabled,zoomLevels){
+    if(enabled) {
+      this.zoomLevels = zoomLevels;
+    }
+    else this.zoomLevels = null;
+  }
+ 
+  /*
+   * Recalculates the lr and ul to a proper aspect. It also takes into account zoomLevels when present.
+   */
+  this.checkBbox = function() {
+    var center = this.getCenter();
+    var half = new Array(this.size[0]/2, this.size[1]/2);
+    var res = this.getFixedScale();
+    this.lr = new Array(center[0]+half[0]*res, center[1]-half[1]*res);
+    this.ul = new Array(center[0]-half[0]*res, center[1]+half[1]*res);
+  }
+  /**
    * Returns the XY center of this extent
    * @return  array of XY for th center of the extent
    */
@@ -56,9 +152,22 @@
    * @return     point array of XY coordinates
    */
   this.getXY = function(pl) {
-    var x = this.ul[0]+pl[0]*this.res[0];
-    var y = this.ul[1]- pl[1]*this.res[1];
-    return new Array(x,y);
+    //switch(this.model.getSRS()) {
+    //  case "EPSG:GMAPS":       //@TODO Cleanup this hack
+    //    gmap=this.model.getParam("gmap");
+    //    if(gmap){
+    //      p=new GPoint(pl[0],pl[1]);
+    //      latlng=gmap.fromDivPixelToLatLng(p);
+    //      latlng=new Array(latlng.lng(),latlng.lat());
+    //    }
+    //    else alert("Extent: gmap not defined");
+    //    break;
+    //  default:
+    //    latlng=new Array(this.ul[0]+pl[0]*this.res[0],this.ul[1]- pl[1]*this.res[1]);
+    //    break;
+    //}
+    latlng=new Array(this.ul[0]+pl[0]*this.res[0],this.ul[1]- pl[1]*this.res[1]);
+    return latlng;
   }
 
   /**
@@ -67,6 +176,11 @@
    * @return     point array of pxiel/line coordinates w.r.t. top left corner
    */
   this.getPL = function(xy) {
+    //switch(this.model.getSRS()) {
+    //  case "EPSG:GMAPS":       //@TODO Cleanup this hack
+    //    return xy;
+    //}
+    
     var p = Math.floor( (xy[0]-this.ul[0])/this.res[0] );
     var l = Math.floor( (this.ul[1]-xy[1])/this.res[1] );
     return new Array(p,l);
@@ -96,6 +210,9 @@
       newres= nRmax ;
     }
  */
+    if (this.zoomLevels) {
+      newres=this.getFixedScale(newres);
+    }
     this.lr = new Array(center[0]+half[0]*newres, center[1]-half[1]*newres);
     this.ul = new Array(center[0]-half[0]*newres, center[1]+half[1]*newres);
 
@@ -166,6 +283,8 @@
   this.getScale = function() {
     var pixRes = null;
     switch(this.model.getSRS()) {
+      case "EPSG:GMAPS":
+        break;
       case "EPSG:4326":				//all projection codes in degrees
       case "EPSG:4269":				
         pixRes = this.res[0]*degToMeter;
@@ -228,6 +347,7 @@
     }
 */
     extent.setResolution( new Array(extent.model.getWindowWidth(), extent.model.getWindowHeight() ) );
+    extent.checkBbox();
   }
   if ( initialRes ) this.init(this, initialRes);
 
Index: lib/spatial/mapbuilder/lib/tool/Caps2Context.js
===================================================================
--- lib/spatial/mapbuilder/lib/tool/Caps2Context.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/Caps2Context.js	(revision 4307)
@@ -1,3 +1,13 @@
+/*
+Author:   
+License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: Caps2Context.js 3881 2008-02-27 15:41:07Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/tool/ToolBase.js");
+
 /**
 
  * Build a Web Map Context (WMC) from a Web Map Server getCapabilities response.
@@ -32,9 +42,9 @@
 
   for (var j=0;j<toolNode.childNodes.length;j++) {
 
-    if (toolNode.childNodes[j].firstChild && toolNode.childNodes[j].firstChild.nodeValue) {
+    if (getNodeValue(toolNode.childNodes[j])) {
 
-      this.stylesheet.setParameter(toolNode.childNodes[j].nodeName,toolNode.childNodes[j].firstChild.nodeValue);
+      this.stylesheet.setParameter(toolNode.childNodes[j].nodeName,getNodeValue(toolNode.childNodes[j]));
 
     }
 
Index: lib/spatial/mapbuilder/lib/tool/EditContext.js
===================================================================
--- lib/spatial/mapbuilder/lib/tool/EditContext.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/EditContext.js	(revision 4307)
@@ -2,7 +2,7 @@
 Author:       Mike Adair  mike.adairATccrs.nrcan.gc.ca
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: EditContext.js 3881 2008-02-27 15:41:07Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -23,8 +23,8 @@
 
   // Set stylesheet parameters for all the child nodes from the config file
   for (var j=0;j<toolNode.childNodes.length;j++) {
-    if (toolNode.childNodes[j].firstChild && toolNode.childNodes[j].firstChild.nodeValue) {
-      this.stylesheet.setParameter(toolNode.childNodes[j].nodeName,toolNode.childNodes[j].firstChild.nodeValue);
+    if (getNodeValue(toolNode.childNodes[j])) {
+      this.stylesheet.setParameter(toolNode.childNodes[j].nodeName,getNodeValue(toolNode.childNodes[j]));
     }
   }
 
@@ -41,7 +41,7 @@
     this.stylesheet.setParameter("format", this.model.getImageFormat() );
     var newNode = this.stylesheet.transformNodeToObject(feature);
     Sarissa.setXpathNamespaces(newNode, this.targetModel.namespace);
-    if (this.debug) alert(newNode.xml);
+    mbDebugMessage(this, newNode.xml);
     this.targetModel.setParam('addLayer',newNode.documentElement);
   }
 
@@ -53,7 +53,7 @@
     var feature = this.model.getFeatureNode(featureName);
     var newNode = this.stylesheet.transformNodeToObject(feature);
     Sarissa.setXpathNamespaces(newNode, this.targetModel.namespace);
-    if (this.debug) alert(newNode.xml);
+    mbDebugMessage(this, newNode.xml);
     this.targetModel.setParam('addLayer',newNode.documentElement);
   }
 
Index: lib/spatial/mapbuilder/lib/tool/xsl/wfs_DescribeFeatureType.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/tool/xsl/wfs_DescribeFeatureType.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/xsl/wfs_DescribeFeatureType.xsl	(revision 4307)
@@ -1,81 +1,6 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:wfs="http://www.opengis.net/wfs" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ogc="http://www.opengis.net/ogc" xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:gml="http://www.opengis.net/gml" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/><xsl:param name="httpMethod">get</xsl:param><xsl:template match="/wfs:WFS_Capabilities/wfs:FeatureTypeList"><DescribeFeatureType version="1.0.0" service="WFS"><xsl:apply-templates select="wfs:FeatureType"/></DescribeFeatureType></xsl:template><xsl:template match="wfs:FeatureType"><xsl:choose><xsl:when test="$httpMethod='post'"><TypeName><xsl:value-of select="wfs:Name"/></TypeName></xsl:when><xsl:otherwise><mb:QueryString><xsl:variable name="query">
 
-
-
-<!--
-
-Description: transforms a WFS FeatureType node to a DescribeFeatureType request
-
-Author:      adair
-
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-
-
-$Id$
-
-$Name$
-
--->
-
-
-
-<xsl:stylesheet version="1.0" 
-
-    xmlns:wfs="http://www.opengis.net/wfs"
-
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-
-		xmlns:ogc="http://www.opengis.net/ogc"
-
-    xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" 
-
-		xmlns:gml="http://www.opengis.net/gml"
-
-    xmlns:xlink="http://www.w3.org/1999/xlink">
-
-
-
-  <xsl:output method="xml" omit-xml-declaration="no" encoding="utf-8" indent="yes"/>
-
-
-
-  <xsl:param name="httpMethod">get</xsl:param>
-
-  
-
-  <!-- template rule matching source root element -->
-
-  <xsl:template match="/wfs:WFS_Capabilities/wfs:FeatureTypeList">
-
-    <DescribeFeatureType version="1.0.0" service="WFS">
-
-      <xsl:apply-templates select="wfs:FeatureType"/>
-
-    </DescribeFeatureType>
-
-  </xsl:template>
-
-
-
-  <!-- template rule matching source root element -->
-
-  <xsl:template match="wfs:FeatureType">
-
-    <xsl:choose>
-
-      <xsl:when test="$httpMethod='post'">
-
-        <TypeName><xsl:value-of select="wfs:Name"/></TypeName>
-
-      </xsl:when>
-
-      <xsl:otherwise>
-
-        <mb:QueryString>
-
-          <xsl:variable name="query">
-
       request=DescribeFeatureType
 
  &amp;version=1.0.0
@@ -82,25 +7,4 @@
 
  &amp;service=WFS
 
-&amp;typename=<xsl:value-of select="wfs:Name"/>
-
-          </xsl:variable>
-
-          <xsl:value-of select="translate(normalize-space($query),' ', '' )" disable-output-escaping="no"/>
-
-        </mb:QueryString>
-
-      </xsl:otherwise>
-
-    </xsl:choose>
-
-  </xsl:template>
-
-
-
-  <xsl:template match="text()|@*"/>
-
-
-
-</xsl:stylesheet>
-
+&amp;typename=<xsl:value-of select="wfs:Name"/></xsl:variable><xsl:value-of select="translate(normalize-space($query),' ', '' )" disable-output-escaping="no"/></mb:QueryString></xsl:otherwise></xsl:choose></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/tool/xsl/wfs_Update.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/tool/xsl/wfs_Update.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/xsl/wfs_Update.xsl	(revision 4307)
@@ -1,104 +1,2 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
-
-
-
-<!--
-
-Description: Extract FeatureMembers from a FeatureCollection and build
-
-  into a WFS Insert transaction.
-
-Author:      Cameron Shorter
-
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-
-
-$Id$
-
--->
-
-
-
-<xsl:stylesheet version="1.0" 
-
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-
-    xmlns:wfs="http://www.opengis.net/wfs"
-
-    xmlns:ogc="http://www.opengis.net/ogc"
-
-    xmlns:gml="http://www.opengis.net/gml">
-
-
-
-  <xsl:output method="xml" omit-xml-declaration="no" encoding="utf-8" indent="yes"/>
-
-
-
-  <!-- Match root -->
-
-  <xsl:template match="/">
-
-    <wfs:Transaction service="WFS" version="1.0.0">
-
-      <xsl:apply-templates/>
-
-    </wfs:Transaction>
-
-  </xsl:template>
-
-
-
-  <!-- Match featureMember -->
-
-  <xsl:template match="gml:featureMember/*[@fid]">
-
-    <wfs:Update typeName="{name()}">
-
-      <ogc:Filter>
-
-        <ogc:FeatureId fid="{./@fid}"/>
-
-      </ogc:Filter>
-
-      <xsl:for-each select="./*">
-
-        <wfs:Property>
-
-          <wfs:Name>
-
-            <xsl:value-of select="name()"/>
-
-          </wfs:Name>
-
-          <wfs:Value>
-
-            <xsl:if test="./*">
-
-              <xsl:copy-of select="./*"/>
-
-            </xsl:if>
-
-            <xsl:if test="not(./*)">
-
-              <xsl:value-of select="."/>
-
-            </xsl:if>
-
-          </wfs:Value>
-
-        </wfs:Property>
-
-      </xsl:for-each>
-
-    </wfs:Update>
-
-  </xsl:template>
-
-
-
-  <xsl:template match="text()|@*"/>
-
-</xsl:stylesheet>
-
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wfs="http://www.opengis.net/wfs" xmlns:ogc="http://www.opengis.net/ogc" xmlns:gml="http://www.opengis.net/gml" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/><xsl:template match="/"><wfs:Transaction service="WFS" version="1.0.0"><xsl:apply-templates/></wfs:Transaction></xsl:template><xsl:template match="gml:featureMember/*[@fid]"><wfs:Update typeName="{name()}"><ogc:Filter><ogc:FeatureId fid="{./@fid}"/></ogc:Filter><xsl:for-each select="./*"><wfs:Property><wfs:Name><xsl:value-of select="name()"/></wfs:Name><wfs:Value><xsl:if test="./*"><xsl:copy-of select="./*"/></xsl:if><xsl:if test="not(./*)"><xsl:value-of select="."/></xsl:if></wfs:Value></wfs:Property></xsl:for-each></wfs:Update></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/tool/MovieLoop.js
===================================================================
--- lib/spatial/mapbuilder/lib/tool/MovieLoop.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/MovieLoop.js	(revision 4307)
@@ -1,7 +1,7 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
 Dependancies: Context
-$Id$
+$Id: MovieLoop.js 3881 2008-02-27 15:41:07Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -24,19 +24,14 @@
   this.model.setParam("firstFrame", 0);
   this.timestampIndex = 0;
   window.movieLoop = this;
+  this.isRunning = false;
+  this.frameIsLoading = false;
 
-  //
-  var framesPerSecond = toolNode.selectSingleNode("mb:framesPerSecond");
-  if (framesPerSecond) {
-    this.delay = 1000/framesPerSecond.firstChild.nodeValue;
-  } else {
-    this.delay = 1000/10; //milliseconds
-  }
+  //delay in milliseconds
+  this.delay = 1000/this.getProperty("mb:framesPerSecond", 10);
 
-  //set a limit to the munber of frames to be loaded
-  this.maxFrames = 30;
-  var maxFrames = toolNode.selectSingleNode("mb:maxFrames");
-  if (maxFrames) this.maxFrames = maxFrames.firstChild.nodeValue;
+  //set a limit to the number of frames to be loaded
+  this.maxFrames = this.getProperty("mb:maxFrames", 30);
 
   /**
    * Sets the frame to the specified index in the frame array
@@ -44,10 +39,13 @@
    */
   this.setFrame = function(index) {
     var timestampList = this.model.timestampList;
+    var ts;
     if (this.timestampIndex!=null) {
-      var timestamp = timestampList.childNodes[this.timestampIndex];
-      timestamp.setAttribute("current", "0");
-      this.model.setParam("timestamp", this.timestampIndex);
+      var ts = timestampList.childNodes[this.timestampIndex];
+      if (ts) {
+        ts.setAttribute("current", "0");
+        this.model.setParam("timestamp", this.timestampIndex);
+      }
     }
     var firstFrame = this.model.getParam("firstFrame");
     var lastFrame = this.model.getParam("lastFrame");
@@ -54,13 +52,14 @@
     if (index > lastFrame) index = firstFrame;
     if (index < firstFrame) index = lastFrame;
     this.timestampIndex = index;
-    timestamp = timestampList.childNodes[this.timestampIndex];
-    timestamp.setAttribute("current", "1");
+    ts = timestampList.childNodes[this.timestampIndex];
+    ts.setAttribute("current", "1");
     this.model.setParam("timestamp", this.timestampIndex);
   }
 
   /**
-   * Advances the frame array by the frame increment
+   * Advances the frame array by the frame increment. 
+   * 
    * @param step optional parameter to override default frame increment
    */
   this.nextFrame = function(step) {
@@ -67,7 +66,13 @@
     var objRef = window.movieLoop;
     var increment = objRef.frameIncrement;
     if (step) increment = step;   //arg passed in overrides default
-    objRef.setFrame(objRef.timestampIndex + increment);
+    if (!this.frameIsLoading) {
+        // play() will continue calling nextFrame, so that 
+        // nextFrame() will continually be called at a regular interval, until the current frame is loaded        
+        // The 'bug' is that if the user clicks the next button rapidly, subsequent requests will be ignored
+        // while the initial frame is loading. This needs to be resolved.
+	    objRef.setFrame(objRef.timestampIndex + increment);
+	}
   }
 
   /**
@@ -96,13 +101,37 @@
     objRef.setFrame(objRef.model.getParam("firstFrame"));
   }
   this.model.addListener("loadModel",this.reset,this);
-  this.model.addListener("bbox",this.reset,this);
+  
+  /**
+   * initialize the movie loop. This only happens at the first bbox event,
+   * which shows us that the map is loaded.
+   */
+  this.init = function(objRef) {
+    //TBD: this is an ugly workaround because we do not have an event that
+    // tells us when the OL map finished loading. 
+    if (!objRef.initialized) {
+      objRef.initialized = true;
+      objRef.reset(objRef);
+    }
+  }
+  this.model.addListener("bbox", this.init, this);
+  
+  /**
+   * set the initialized state of the movie loop to false
+   */
+  this.uninit = function(objRef) {
+    objRef.initialized = false;
+  }
+  this.model.addListener("newModel", this.uninit, this);
 
   /**
    * Starts the movie loop playing by using a JavaScript timer.
    */
   this.play = function() {
-    this.movieTimer = setInterval('window.movieLoop.nextFrame()',this.delay);
+  	if (!this.isRunning) {
+	    this.movieTimer = setInterval('window.movieLoop.nextFrame()',this.delay);
+	    this.isRunning = true;
+	}
   }
   
   /**
@@ -109,6 +138,7 @@
    * Stops the JavaScript movie loop timer.
    */
   this.pause = function() {
+    this.isRunning = false;
     clearInterval(this.movieTimer);
   }
   
@@ -116,7 +146,7 @@
    * Stops the JavaScript movie loop timer and sets the index back to the first 
    * frame.
    */
-  this.stop = function() {
+  this.stop = function() { 
     this.pause();
     this.reset(this);
   }
Index: lib/spatial/mapbuilder/lib/tool/FeatureSelectHandler.js
===================================================================
--- lib/spatial/mapbuilder/lib/tool/FeatureSelectHandler.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/tool/FeatureSelectHandler.js	(revision 4307)
@@ -0,0 +1,284 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: FeatureSelectHandler.js 3842 2008-02-13 17:22:04Z ahocevar $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/tool/ToolBase.js");
+mapbuilder.loadScript(baseDir+"/util/openlayers/OpenLayers.js");
+
+/**
+ * Manages mouseover and clicks on vector features in the map.
+ * This tool works with models that are linked to a OL vector layer,
+ * using eg. the GmlRendererOL widget. Models have to fire the
+ * 'gmlRendererLayer' event, which will activate the tool for the
+ * layer.
+ * This tool also fires "mouseoverFeature" and "mouseoutFeature"
+ * events, setting the fid of the feature below the mouse cursor
+ * as param of the model.
+ * @constructor
+ * @base ToolBase
+ * @author Andreas Hocevar andreas.hocevarATgmail.com
+ * @param toolNode The tool node from the config XML file.
+ * @param model The model containing this tool.
+ */
+function FeatureSelectHandler(toolNode, model) {
+  ToolBase.apply(this, new Array(toolNode, model));
+   
+  /**
+   * Map for this FeatureSelectHandler. We keep a reference
+   * to the map we created the control for, to prevent ourselves
+   * from removing the control from a map that does not exist
+   * anymore.
+   */
+  this.map = null;
+  
+  this.sourceModels = new Array();
+  
+  /**
+   * Tool Initialisation - Step 1 of 3.
+   * This is called when the config finished loading, so we know
+   * our context (targetModel).
+   * @param objRef This object
+   */
+  this.configInit = function(objRef) {
+    objRef.targetModel.addListener('loadModel', objRef.contextInit, objRef);
+  }
+  this.model.addListener('init', this.configInit, this)
+  
+  this.clear = function(objRef) {
+    if (objRef.control) {
+      objRef.map = null;
+      objRef.control.destroy();
+      objRef.control = null;
+    }
+  }
+  this.model.addListener("newModel", this.clear, this);
+
+  /**
+   * Tool Initialisation - Step 2 of 3.
+   * This is called when the context model finished loading, so we
+   * know that we have a map available.
+   * @param objRef This object
+   */
+  this.contextInit = function(objRef) {
+    objRef.targetModel.addListener("newModel", objRef.clear, objRef);
+    objRef.model.addListener('gmlRendererLayer', objRef.init, objRef);
+    // Check carefully if we have to init manually. This is the case when
+    // the gmlRendererLayer is rendered, but does not know about the
+    // FeatureSelectHandler yet.
+    if (objRef.targetModel.map && objRef.model.getParam('gmlRendererLayer') && !objRef.control) {
+      objRef.init(objRef);
+    }
+  }
+  
+  /**
+   * Tool Initialisation - Step 3 of 3.
+   * Turns on feature select when the gmlRendererLayer event is fired.
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} class of the OL control.
+   */
+  this.init = function(objRef) {
+    // get the source models
+    var sourceModel;
+    // if we have mergeModels, take sourceModels from there
+    if (objRef.model.mergeModels) {
+      objRef.sourceModels = objRef.model.mergeModels;
+    } else {
+      // if we hava a plain model, just use it
+      objRef.sourceModels.push(objRef.model);
+    } 
+    for (var i=0; i<objRef.sourceModels.length; i++) {
+      objRef.sourceModels[i].addListener('highlightFeature', objRef.highlight, objRef);
+      objRef.sourceModels[i].addListener('dehighlightFeature', objRef.dehighlight, objRef);
+    }
+    
+    // init the control
+    var layer = objRef.model.getParam('gmlRendererLayer');
+    if (objRef.map == objRef.targetModel.map &&
+        objRef.control && !layer) {
+      //objRef.control.deactivate();
+      objRef.map.removeControl(objRef.control);
+      objRef.control.destroy();
+      objRef.control = null;
+    } else if (layer) {
+      if (!objRef.control) {
+        objRef.control = new OpenLayers.Control.SelectFeature(layer, {
+          hover: true,
+          onSelect: objRef.onSelect,
+          onUnselect: objRef.onUnselect,
+          mbFeatureSelectHandler: objRef,
+          select: function(feature) {
+            feature.mbFeatureSelectHandler = this.mbFeatureSelectHandler;
+            if (feature.mbSelectStyle) {
+              this.selectStyle = feature.mbSelectStyle.createSymbolizer ?
+                  feature.mbSelectStyle.createSymbolizer(feature) :
+                  feature.mbSelectStyle;
+            }
+            OpenLayers.Control.SelectFeature.prototype.select.apply(this, arguments);
+          }
+        });
+        objRef.map = objRef.targetModel.map;
+        objRef.map.addControl(objRef.control);
+      }
+      objRef.control.activate();
+    }
+  }
+  
+  /**
+   * extension for the OpenLayers.Feature.Vector.destroy method.
+   * Will be applied to features touched by this tool.
+   */
+  var destroyFeature = function() {
+    var featureSelectHandler = this.mbFeatureSelectHandler;
+    if (this.layer.events && featureSelectHandler) {
+      this.layer.events.unregister('mousedown', this, featureSelectHandler.onClick);
+      this.layer.events.unregister('mousemove', this, featureSelectHandler.onHover);
+    }
+    this.mbFeatureSelectHandler = null;
+    OpenLayers.Feature.Vector.prototype.destroy.apply(this, arguments);
+  }
+
+  /**
+   * This method is triggered when the mouse is over a vector
+   * feature. It registers priority events mousedown and
+   * mousemove, which will call this widget's onClick/onHover
+   * method in the context of a feature. This way we address
+   * two problems with the OpenLayers SelectFeature control:<pre>
+   *      - for the info popup, we need the screen coordinates
+   *        which we do not get from the handler directly.
+   *      - when the active tool changes, something in the
+   *        priority of OL event handlers changes, so the
+   *        click event on the feature gets lost. By registering
+   *        our priority handler and calling Event.stop() in
+   *        the target method, we make sure that our event is
+   *        handled and no other event handlers are triggered.
+   * </pre>
+   * @param feature OpenLayers feature
+   */
+  this.onSelect = function(feature) {
+    if (!feature) return;
+    var objRef = this.mbFeatureSelectHandler;
+    for (var i=0; i<objRef.sourceModels.length; i++) {
+      objRef.sourceModels[i].setParam("mouseoverFeature", feature.fid);
+    }
+    // check if onSelect was triggered by a mouse event. If not, do not register for
+    // mousedown and mousemove events. This is the case when selection was externally
+    // triggered by the highlightFeature event
+    if (feature.layer.events && !feature.mbNoMouseEvent) {
+      feature.destroy = destroyFeature;
+      feature.layer.events.registerPriority('mousedown', feature, objRef.onClick);
+      feature.layer.events.registerPriority('mousemove', feature, objRef.onHover);
+    } else {
+      feature.mbNoMouseEvent = null;
+    }
+  }
+  
+  /**
+   * This method is triggered when the mouse is moving out
+   * of a vector feature. It removes the event handler we
+   * registered in this widget's onSelect method.
+   * @param feature OpenLayers feature
+   */
+  this.onUnselect = function(feature) {
+    if (!feature) return;
+    var objRef = this.mbFeatureSelectHandler || feature.mbFeatureSelectHandler;
+    for (var i=0; i<objRef.sourceModels.length; i++) {
+      objRef.sourceModels[i].setParam("mouseoutFeature", feature.fid);
+    }
+    objRef.model.setParam("olFeatureOut", feature);
+    if (feature.layer.events) {
+      feature.layer.events.unregister('mousedown', feature, objRef.onClick);
+    }
+  }
+  
+  /**
+   * This method is triggered when a user clicks on a feature.
+   * It is called by OpenLayers event handling in the context
+   * of a feature. This means that 'this' in this method refers
+   * to an {OpenLayers.Feature}. Widgets listening to the
+   * olFeatureSelect have access to the event, because setParam
+   * is used to set the reference to the event.
+   * @param evt OpenLayers event
+   */
+  this.onClick = function(evt) {
+    // pass the feature to the event object
+    evt.feature = this;
+    var objRef = this.mbFeatureSelectHandler;
+    objRef.model.setParam("olFeatureSelect", evt);
+    OpenLayers.Event.stop(evt);
+  }
+  
+  /**
+   * This method is triggered when the mouse is over a feature.
+   * It is called by OpenLayers event handling in the context
+   * of a feature. This means that 'this' in this method refers
+   * to an {OpenLayers.Feature}. Widgets listening to the
+   * olFeatureHover have access to the event, because setParam
+   * is used to set the reference to the event.
+   * @param evt OpenLayers event
+   */
+  this.onHover = function(evt) {
+    var objRef = this.mbFeatureSelectHandler;
+    if (this.layer && this.layer.events) {
+      // unregister the mousemove event, because we already know that
+      // the mouse moved and we can then proceed to our hover popup.
+      this.layer.events.unregister('mousemove', this, objRef.onHover);
+    }
+    evt.feature = this;
+    objRef.model.setParam("olFeatureHover", evt);
+  }
+
+  /**
+   * Highlights the specified feature. This method is usually
+   * triggered by setting the 'highlightFeature' param to the
+   * fid of a feature to be highlighted.
+   * @param objRef reference to this tool object
+   * @param fid GML feature id of the feature to highlight. If
+   * not specified, this is taken from the highlightFeature
+   * model param.
+   */
+  this.highlight = function(objRef, fid) {
+    var model, feature;
+    var layer = objRef.model.getParam('gmlRendererLayer');
+    for (var i=0; i<objRef.sourceModels.length; i++) {
+      model = objRef.sourceModels[i]
+      if (!layer) return;
+      if (!fid) {
+        fid = model.getParam('highlightFeature');
+      }
+      feature = layer.getFeatureByFid(fid);
+      if (feature && !feature.mbHidden) {
+        // add a tag to the feature to indicate that it was not selected by mouse action
+        feature.mbNoMouseEvent = true;
+        objRef.control.select(feature);
+      }
+    }
+  }
+  
+  /**
+   * Dehighlights the specified feature. This method is usually
+   * triggered by setting the 'dehighlightFeature' param to the
+   * fid of a feature to be highlighted.
+   * @param objRef reference to this tool object
+   * @param fid GML feature id of the feature to highlight. If
+   * not specified, this is taken from the dehighlightFeature
+   * model param.
+   */
+  this.dehighlight = function(objRef, fid) {
+    var model, feature;
+    var layer = objRef.model.getParam('gmlRendererLayer');
+    for (var i=0; i<objRef.sourceModels.length; i++) {
+      model = objRef.sourceModels[i];
+      if (!layer) return;
+      if (!fid) {
+        fid = objRef.model.getParam('dehighlightFeature');
+      }
+      feature = layer.getFeatureByFid(fid);
+      if (feature && !feature.mbHidden) {
+        objRef.control.unselect(feature);
+      }
+    }
+  }
+  
+}
